Index: CKEditor/trunk/_source/plugins/link/dialogs/link.js
===================================================================
--- CKEditor/trunk/_source/plugins/link/dialogs/link.js	(revision 5181)
+++ CKEditor/trunk/_source/plugins/link/dialogs/link.js	(revision 5189)
@@ -381,5 +381,5 @@
 						items :
 						[
-							[ editor.lang.common.url, 'url' ],
+							[ editor.lang.link.toUrl, 'url' ],
 							[ editor.lang.link.toAnchor, 'anchor' ],
 							[ editor.lang.link.toEmail, 'email' ]
@@ -437,4 +437,5 @@
 										id : 'url',
 										label : editor.lang.common.url,
+										required: true,
 										onLoad : function ()
 										{
@@ -485,8 +486,4 @@
 												this.setValue( data.url.url );
 											this.allowOnChange = true;
-
-											var linkType = this.getDialog().getContentElement( 'info', 'linkType' );
-											if ( linkType && linkType.getValue() == 'url' )
-												this.select();
 
 										},
@@ -529,7 +526,7 @@
 						[
 							{
-								type : 'html',
+								type : 'fieldset',
 								id : 'selectAnchorText',
-								html : CKEDITOR.tools.htmlEncode( editor.lang.link.selectAnchor ),
+								label : editor.lang.link.selectAnchor,
 								setup : function( data )
 								{
@@ -538,5 +535,88 @@
 									else
 										this.getElement().hide();
-								}
+								},
+								children :
+								[
+									{
+										type : 'hbox',
+										id : 'selectAnchor',
+										children :
+										[
+											{
+												type : 'select',
+												id : 'anchorName',
+												'default' : '',
+												label : editor.lang.link.anchorName,
+												style : 'width: 100%;',
+												items :
+												[
+													[ '' ]
+												],
+												setup : function( data )
+												{
+													this.clear();
+													this.add( '' );
+													for ( var i = 0 ; i < data.anchors.length ; i++ )
+													{
+														if ( data.anchors[i].name )
+															this.add( data.anchors[i].name );
+													}
+
+													if ( data.anchor )
+														this.setValue( data.anchor.name );
+
+													var linkType = this.getDialog().getContentElement( 'info', 'linkType' );
+													if ( linkType && linkType.getValue() == 'email' )
+														this.focus();
+												},
+												commit : function( data )
+												{
+													if ( !data.anchor )
+														data.anchor = {};
+
+													data.anchor.name = this.getValue();
+												}
+											},
+											{
+												type : 'select',
+												id : 'anchorId',
+												'default' : '',
+												label : editor.lang.link.anchorId,
+												style : 'width: 100%;',
+												items :
+												[
+													[ '' ]
+												],
+												setup : function( data )
+												{
+													this.clear();
+													this.add( '' );
+													for ( var i = 0 ; i < data.anchors.length ; i++ )
+													{
+														if ( data.anchors[i].id )
+															this.add( data.anchors[i].id );
+													}
+
+													if ( data.anchor )
+														this.setValue( data.anchor.id );
+												},
+												commit : function( data )
+												{
+													if ( !data.anchor )
+														data.anchor = {};
+
+													data.anchor.id = this.getValue();
+												}
+											}
+										],
+										setup : function( data )
+										{
+											if ( data.anchors.length > 0 )
+												this.getElement().show();
+											else
+												this.getElement().hide();
+										}
+									}
+								]
 							},
 							{
@@ -544,88 +624,10 @@
 								id : 'noAnchors',
 								style : 'text-align: center;',
-								html : '<div>' + CKEDITOR.tools.htmlEncode( editor.lang.link.noAnchors ) + '</div>',
+								html : '<div role="label" tabIndex="-1">' + CKEDITOR.tools.htmlEncode( editor.lang.link.noAnchors ) + '</div>',
+								// Focus the first element defined in above html.
+								focus : true,
 								setup : function( data )
 								{
 									if ( data.anchors.length < 1 )
-										this.getElement().show();
-									else
-										this.getElement().hide();
-								}
-							},
-							{
-								type : 'hbox',
-								id : 'selectAnchor',
-								children :
-								[
-									{
-										type : 'select',
-										id : 'anchorName',
-										'default' : '',
-										label : editor.lang.link.anchorName,
-										style : 'width: 100%;',
-										items :
-										[
-											[ '' ]
-										],
-										setup : function( data )
-										{
-											this.clear();
-											this.add( '' );
-											for ( var i = 0 ; i < data.anchors.length ; i++ )
-											{
-												if ( data.anchors[i].name )
-													this.add( data.anchors[i].name );
-											}
-
-											if ( data.anchor )
-												this.setValue( data.anchor.name );
-
-											var linkType = this.getDialog().getContentElement( 'info', 'linkType' );
-											if ( linkType && linkType.getValue() == 'email' )
-												this.focus();
-										},
-										commit : function( data )
-										{
-											if ( !data.anchor )
-												data.anchor = {};
-
-											data.anchor.name = this.getValue();
-										}
-									},
-									{
-										type : 'select',
-										id : 'anchorId',
-										'default' : '',
-										label : editor.lang.link.anchorId,
-										style : 'width: 100%;',
-										items :
-										[
-											[ '' ]
-										],
-										setup : function( data )
-										{
-											this.clear();
-											this.add( '' );
-											for ( var i = 0 ; i < data.anchors.length ; i++ )
-											{
-												if ( data.anchors[i].id )
-													this.add( data.anchors[i].id );
-											}
-
-											if ( data.anchor )
-												this.setValue( data.anchor.id );
-										},
-										commit : function( data )
-										{
-											if ( !data.anchor )
-												data.anchor = {};
-
-											data.anchor.id = this.getValue();
-										}
-									}
-								],
-								setup : function( data )
-								{
-									if ( data.anchors.length > 0 )
 										this.getElement().show();
 									else
@@ -650,4 +652,5 @@
 								id : 'emailAddress',
 								label : editor.lang.link.emailAddress,
+								required : true,
 								validate : function()
 								{
@@ -737,16 +740,16 @@
 								type : 'select',
 								id : 'linkTargetType',
-								label : editor.lang.link.target,
+								label : editor.lang.common.target,
 								'default' : 'notSet',
 								style : 'width : 100%;',
 								'items' :
 								[
-									[ editor.lang.link.targetNotSet, 'notSet' ],
+									[ editor.lang.common.notSet, 'notSet' ],
 									[ editor.lang.link.targetFrame, 'frame' ],
 									[ editor.lang.link.targetPopup, 'popup' ],
-									[ editor.lang.link.targetNew, '_blank' ],
-									[ editor.lang.link.targetTop, '_top' ],
-									[ editor.lang.link.targetSelf, '_self' ],
-									[ editor.lang.link.targetParent, '_parent' ]
+									[ editor.lang.common.targetNew, '_blank' ],
+									[ editor.lang.common.targetTop, '_top' ],
+									[ editor.lang.common.targetSelf, '_self' ],
+									[ editor.lang.common.targetParent, '_parent' ]
 								],
 								onChange : targetChanged,
@@ -793,143 +796,146 @@
 						[
 							{
-								type : 'html',
-								html : CKEDITOR.tools.htmlEncode( editor.lang.link.popupFeatures )
-							},
-							{
-								type : 'hbox',
+								type : 'fieldset',
+								label : editor.lang.link.popupFeatures,
 								children :
 								[
 									{
-										type : 'checkbox',
-										id : 'resizable',
-										label : editor.lang.link.popupResizable,
-										setup : setupPopupParams,
-										commit : commitPopupParams
+										type : 'hbox',
+										children :
+										[
+											{
+												type : 'checkbox',
+												id : 'resizable',
+												label : editor.lang.link.popupResizable,
+												setup : setupPopupParams,
+												commit : commitPopupParams
+											},
+											{
+												type : 'checkbox',
+												id : 'status',
+												label : editor.lang.link.popupStatusBar,
+												setup : setupPopupParams,
+												commit : commitPopupParams
+
+											}
+										]
 									},
 									{
-										type : 'checkbox',
-										id : 'status',
-										label : editor.lang.link.popupStatusBar,
-										setup : setupPopupParams,
-										commit : commitPopupParams
-
-									}
-								]
-							},
-							{
-								type : 'hbox',
-								children :
-								[
-									{
-										type : 'checkbox',
-										id : 'location',
-										label : editor.lang.link.popupLocationBar,
-										setup : setupPopupParams,
-										commit : commitPopupParams
-
+										type : 'hbox',
+										children :
+										[
+											{
+												type : 'checkbox',
+												id : 'location',
+												label : editor.lang.link.popupLocationBar,
+												setup : setupPopupParams,
+												commit : commitPopupParams
+
+											},
+											{
+												type : 'checkbox',
+												id : 'toolbar',
+												label : editor.lang.link.popupToolbar,
+												setup : setupPopupParams,
+												commit : commitPopupParams
+
+											}
+										]
 									},
 									{
-										type : 'checkbox',
-										id : 'toolbar',
-										label : editor.lang.link.popupToolbar,
-										setup : setupPopupParams,
-										commit : commitPopupParams
-
-									}
-								]
-							},
-							{
-								type : 'hbox',
-								children :
-								[
-									{
-										type : 'checkbox',
-										id : 'menubar',
-										label : editor.lang.link.popupMenuBar,
-										setup : setupPopupParams,
-										commit : commitPopupParams
-
+										type : 'hbox',
+										children :
+										[
+											{
+												type : 'checkbox',
+												id : 'menubar',
+												label : editor.lang.link.popupMenuBar,
+												setup : setupPopupParams,
+												commit : commitPopupParams
+
+											},
+											{
+												type : 'checkbox',
+												id : 'fullscreen',
+												label : editor.lang.link.popupFullScreen,
+												setup : setupPopupParams,
+												commit : commitPopupParams
+
+											}
+										]
 									},
 									{
-										type : 'checkbox',
-										id : 'fullscreen',
-										label : editor.lang.link.popupFullScreen,
-										setup : setupPopupParams,
-										commit : commitPopupParams
-
-									}
-								]
-							},
-							{
-								type : 'hbox',
-								children :
-								[
-									{
-										type : 'checkbox',
-										id : 'scrollbars',
-										label : editor.lang.link.popupScrollBars,
-										setup : setupPopupParams,
-										commit : commitPopupParams
-
+										type : 'hbox',
+										children :
+										[
+											{
+												type : 'checkbox',
+												id : 'scrollbars',
+												label : editor.lang.link.popupScrollBars,
+												setup : setupPopupParams,
+												commit : commitPopupParams
+
+											},
+											{
+												type : 'checkbox',
+												id : 'dependent',
+												label : editor.lang.link.popupDependent,
+												setup : setupPopupParams,
+												commit : commitPopupParams
+
+											}
+										]
 									},
 									{
-										type : 'checkbox',
-										id : 'dependent',
-										label : editor.lang.link.popupDependent,
-										setup : setupPopupParams,
-										commit : commitPopupParams
-
-									}
-								]
-							},
-							{
-								type : 'hbox',
-								children :
-								[
-									{
-										type :  'text',
-										widths : [ '30%', '70%' ],
-										labelLayout : 'horizontal',
-										label : editor.lang.link.popupWidth,
-										id : 'width',
-										setup : setupPopupParams,
-										commit : commitPopupParams
-
+										type : 'hbox',
+										children :
+										[
+											{
+												type :  'text',
+												widths : [ '30%', '70%' ],
+												labelLayout : 'horizontal',
+												label : editor.lang.link.popupWidth,
+												id : 'width',
+												setup : setupPopupParams,
+												commit : commitPopupParams
+
+											},
+											{
+												type :  'text',
+												labelLayout : 'horizontal',
+												widths : [ '55%', '45%' ],
+												label : editor.lang.link.popupLeft,
+												id : 'left',
+												setup : setupPopupParams,
+												commit : commitPopupParams
+
+											}
+										]
 									},
 									{
-										type :  'text',
-										labelLayout : 'horizontal',
-										widths : [ '55%', '45%' ],
-										label : editor.lang.link.popupLeft,
-										id : 'left',
-										setup : setupPopupParams,
-										commit : commitPopupParams
-
-									}
-								]
-							},
-							{
-								type : 'hbox',
-								children :
-								[
-									{
-										type :  'text',
-										labelLayout : 'horizontal',
-										widths : [ '30%', '70%' ],
-										label : editor.lang.link.popupHeight,
-										id : 'height',
-										setup : setupPopupParams,
-										commit : commitPopupParams
-
-									},
-									{
-										type :  'text',
-										labelLayout : 'horizontal',
-										label : editor.lang.link.popupTop,
-										widths : [ '55%', '45%' ],
-										id : 'top',
-										setup : setupPopupParams,
-										commit : commitPopupParams
-
+										type : 'hbox',
+										children :
+										[
+											{
+												type :  'text',
+												labelLayout : 'horizontal',
+												widths : [ '30%', '70%' ],
+												label : editor.lang.link.popupHeight,
+												id : 'height',
+												setup : setupPopupParams,
+												commit : commitPopupParams
+
+											},
+											{
+												type :  'text',
+												labelLayout : 'horizontal',
+												label : editor.lang.link.popupTop,
+												widths : [ '55%', '45%' ],
+												id : 'top',
+												setup : setupPopupParams,
+												commit : commitPopupParams
+
+											}
+										]
 									}
 								]
@@ -994,5 +1000,5 @@
 										items :
 										[
-											[ editor.lang.link.langDirNotSet, '' ],
+											[ editor.lang.common.notSet, '' ],
 											[ editor.lang.link.langDirLTR, 'ltr' ],
 											[ editor.lang.link.langDirRTL, 'rtl' ]
@@ -1374,4 +1380,15 @@
 				this.hidePage( 'target' );		//Hide Target tab.
 
+		},
+		// Inital focus on 'url' field if link is of type URL.
+		onFocus : function()
+		{
+			var linkType = this.getContentElement( 'info', 'linkType' ),
+					urlField;
+			if ( linkType && linkType.getValue( ) == 'url' )
+			{
+				urlField = this.getContentElement( 'info', 'url' );
+				urlField.select();
+			}
 		}
 	};
Index: CKEditor/trunk/_source/plugins/listblock/plugin.js
===================================================================
--- CKEditor/trunk/_source/plugins/listblock/plugin.js	(revision 5181)
+++ CKEditor/trunk/_source/plugins/listblock/plugin.js	(revision 5189)
@@ -1,3 +1,3 @@
-﻿/*
+/*
 Copyright (c) 2003-2010, CKSource - Frederico Knabben. All rights reserved.
 For licensing, see LICENSE.html or http://ckeditor.com/license
@@ -10,7 +10,7 @@
 	onLoad : function()
 	{
-		CKEDITOR.ui.panel.prototype.addListBlock = function( name, multiSelect )
+		CKEDITOR.ui.panel.prototype.addListBlock = function( name, definiton )
 		{
-			return this.addBlock( name, new CKEDITOR.ui.listBlock( this.getHolderElement(), multiSelect ) );
+			return this.addBlock( name, new CKEDITOR.ui.listBlock( this.getHolderElement(), definiton ) );
 		};
 
@@ -19,10 +19,16 @@
 				base : CKEDITOR.ui.panel.block,
 
-				$ : function( blockHolder, multiSelect )
+				$ : function( blockHolder, blockDefinition )
 				{
+					blockDefinition = blockDefinition || {};
+
+					var attribs = blockDefinition.attributes || ( blockDefinition.attributes = {} );
+					( this.multiSelect = !!blockDefinition.multiSelect ) &&
+						( attribs[ 'aria-multiselectable' ] = true );
+					// Provide default role of 'listbox'.
+					!attribs.role && ( attribs.role = 'listbox' );
+
 					// Call the base contructor.
-					this.base( blockHolder );
-
-					this.multiSelect = !!multiSelect;
+					this.base.apply( this, arguments );
 
 					var keys = this.keys;
@@ -80,6 +86,7 @@
 						if ( !this._.started )
 						{
-							pendingHtml.push( '<ul class=cke_panel_list>' );
+							pendingHtml.push( '<ul role="presentation" class=cke_panel_list>' );
 							this._.started = 1;
+							this._.size = this._.size || 0;
 						}
 
@@ -88,8 +95,10 @@
 						pendingHtml.push(
 							'<li id=', id, ' class=cke_panel_listItem>' +
-								'<a _cke_focus=1 hidefocus=true' +
+								'<a id="', id, '_option" _cke_focus=1 hidefocus=true' +
 									' title="', title || value, '"' +
 									' href="javascript:void(\'', value, '\')"' +
-									' onclick="CKEDITOR.tools.callFunction(', this._.getClick(), ',\'', value, '\'); return false;">',
+									' onclick="CKEDITOR.tools.callFunction(', this._.getClick(), ',\'', value, '\'); return false;"',
+									' role="option"' +
+									' aria-posinset="' + ++this._.size + '">',
 									html || value,
 								'</a>' +
@@ -105,5 +114,5 @@
 						this._.groups[ title ] = id;
 
-						this._.pendingHtml.push( '<h1 id=', id, ' class=cke_panel_grouptitle>', title, '</h1>' );
+						this._.pendingHtml.push( '<h1 role="presentation" id=', id, ' class=cke_panel_grouptitle>', title, '</h1>' );
 					},
 
@@ -112,4 +121,11 @@
 						this._.close();
 						this.element.appendHtml( this._.pendingHtml.join( '' ) );
+
+						var items = this._.items,
+							doc = this.element.getDocument();
+						for ( var value in items )
+							doc.getById( items[ value ] + '_option' ).setAttribute( 'aria-setsize', this._.size );
+						delete this._.size;
+
 						this._.pendingHtml = [];
 					},
@@ -174,5 +190,10 @@
 							this.unmarkAll();
 
-						this.element.getDocument().getById( this._.items[ value ] ).addClass( 'cke_selected' );
+						var itemId = this._.items[ value ],
+							item = this.element.getDocument().getById( itemId );
+						item.addClass( 'cke_selected' );
+
+						this.element.getDocument().getById( itemId + '_option' ).setAttribute( 'aria-selected', true );
+						this.element.setAttribute( 'aria-activedescendant', itemId + '_option' );
 					},
 
Index: CKEditor/trunk/_source/plugins/maximize/plugin.js
===================================================================
--- CKEditor/trunk/_source/plugins/maximize/plugin.js	(revision 5181)
+++ CKEditor/trunk/_source/plugins/maximize/plugin.js	(revision 5189)
@@ -115,5 +115,5 @@
 					exec : function()
 					{
-						var container = editor.container.getChild( 0 );
+						var container = editor.container.getChild( 1 );
 						var contents = editor.getThemeSpace( 'contents' );
 
Index: CKEditor/trunk/_source/plugins/menu/plugin.js
===================================================================
--- CKEditor/trunk/_source/plugins/menu/plugin.js	(revision 5181)
+++ CKEditor/trunk/_source/plugins/menu/plugin.js	(revision 5189)
@@ -47,6 +47,7 @@
 	CKEDITOR.menu = CKEDITOR.tools.createClass(
 	{
-		$ : function( editor, level )
+		$ : function( editor, definition )
 		{
+			definition = this._.definition = definition || {};
 			this.id = 'cke_' + CKEDITOR.tools.getNextNumber();
 
@@ -54,5 +55,17 @@
 			this.items = [];
 
-			this._.level = level || 1;
+			this._.level = definition.level || 1;
+
+			var panelDefinition = CKEDITOR.tools.extend( {}, definition.panel,
+			{
+				css : editor.skin.editor.css,
+				level : this._.level - 1,
+				block : {}
+			} );
+
+			var attrs = panelDefinition.block.attributes = ( panelDefinition.attributes || {} );
+			// Provide default role of 'menu'.
+			!attrs.role && ( attrs.role = 'menu' );
+			this._.panelDefinition = panelDefinition;
 		},
 
@@ -72,4 +85,8 @@
 					return;
 				}
+
+				// Record parent menu focused item first (#3389).
+				var block = this._.panel.getBlock( this.id );
+				block._.focusIndex = index;
 
 				// Create the submenu, if not available, or clean the existing
@@ -79,7 +96,10 @@
 				else
 				{
-					menu = this._.subMenu = new CKEDITOR.menu( this.editor, this._.level + 1 );
+					menu = this._.subMenu = new CKEDITOR.menu( this.editor,
+								   CKEDITOR.tools.extend( {}, this._.definition, { level : this._.level + 1 }, true ) );
 					menu.parent = this;
 					menu.onClick = CKEDITOR.tools.bind( this.onClick, this );
+					// Sub menu use their own scope for binding onEscape.
+					menu.onEscape = this.onEscape;
 				}
 
@@ -131,16 +151,13 @@
 				if ( !panel )
 				{
-					panel = this._.panel = new CKEDITOR.ui.floatPanel( this.editor, CKEDITOR.document.getBody(),
-						{
-							css : editor.skin.editor.css,
-							level : this._.level - 1,
-							className : editor.skinClass + ' cke_contextmenu'
-						},
-						this._.level);
-
-					panel.onEscape = CKEDITOR.tools.bind( function()
+					panel = this._.panel = new CKEDITOR.ui.floatPanel( this.editor,
+						CKEDITOR.document.getBody(),
+						this._.panelDefinition,
+						this._.level );
+
+					panel.onEscape = CKEDITOR.tools.bind( function( keystroke )
 					{
-						this.onEscape && this.onEscape();
-						this.hide();
+						if ( this.onEscape && this.onEscape( keystroke ) === false )
+							return false;
 					},
 					this );
@@ -153,5 +170,5 @@
 
 					// Create an autosize block inside the panel.
-					var block = panel.addBlock( this.id );
+					var block = panel.addBlock( this.id, this._.panelDefinition.block );
 					block.autoSize = true;
 
@@ -162,5 +179,5 @@
 					keys[ CKEDITOR.SHIFT + 9 ]	= 'prev';	// SHIFT + TAB
 					keys[ 32 ]	= 'click';					// SPACE
-					keys[ 39 ]	= 'click';					// ARROW-RIGHT
+					keys[ ( editor.lang.dir == 'rtl' ? 37 : 39 ) ]	= 'click';  // ARROW-RIGHT/ARROW-LEFT(rtl)
 
 					element = this._.element = block.element;
@@ -206,5 +223,5 @@
 
 				// Build the HTML that composes the menu and its items.
-				var output = [ '<div class="cke_menu">' ];
+				var output = [ '<div class="cke_menu" role="presentation">' ];
 
 				var length = items.length,
@@ -216,5 +233,5 @@
 					if ( lastGroup != item.group )
 					{
-						output.push( '<div class="cke_menuseparator"></div>' );
+						output.push( '<div class="cke_menuseparator" role="separator"></div>' );
 						lastGroup = item.group;
 					}
@@ -291,9 +308,9 @@
 
 			var htmlLabel = this.label;
-			if ( state == CKEDITOR.TRISTATE_DISABLED )
-				htmlLabel = this.editor.lang.common.unavailable.replace( '%1', htmlLabel );
 
 			if ( this.className )
 				classes += ' ' + this.className;
+
+			var hasSubMenu = this.getItems;
 
 			output.push(
@@ -304,5 +321,9 @@
 					' tabindex="-1"' +
 					'_cke_focus=1' +
-					' hidefocus="true"' );
+					' hidefocus="true"' +
+					' role="menuitem"' +
+					( hasSubMenu ? 'aria-haspopup="true"' : '' ) +
+					( state == CKEDITOR.TRISTATE_DISABLED ? 'aria-disabled="true"' : '' ) +
+					( state == CKEDITOR.TRISTATE_ON ? 'aria-pressed="true"' : '' ) );
 
 			// Some browsers don't cancel key events in the keydown but in the
@@ -336,5 +357,5 @@
 						'<span class="cke_label">' );
 
-			if ( this.getItems )
+			if ( hasSubMenu )
 			{
 				output.push(
Index: CKEditor/trunk/_source/plugins/panel/plugin.js
===================================================================
--- CKEditor/trunk/_source/plugins/panel/plugin.js	(revision 5181)
+++ CKEditor/trunk/_source/plugins/panel/plugin.js	(revision 5189)
@@ -79,4 +79,5 @@
 			'<div class="', editor.skinClass ,'"' +
 				' lang="', editor.langCode, '"' +
+				' role="presentation"' +
 				// iframe loading need sometime, keep the panel hidden(#4186).
 				' style="display:none;z-index:' + ( editor.config.baseFloatZIndex + 1 ) + '">' +
@@ -84,4 +85,5 @@
 					' id=', id,
 					' dir=', editor.lang.dir,
+					' role="presentation"' +
 					' class="cke_panel cke_', editor.lang.dir );
 
@@ -97,5 +99,5 @@
 						'<iframe id="', id, '_frame"' +
 							' frameborder="0"' +
-							' src="javascript:void(' );
+							' role="application" src="javascript:void(' );
 
 			output.push(
@@ -156,6 +158,5 @@
 						'</head>' +
 						'<body class="cke_' + dir + ' cke_panel_frame ' + CKEDITOR.env.cssClass + '" style="margin:0;padding:0"' +
-						' onload="( window.CKEDITOR || window.parent.CKEDITOR ).tools.callFunction(' + onLoad + ');">' +
-						'</body>' +
+						' onload="( window.CKEDITOR || window.parent.CKEDITOR ).tools.callFunction(' + onLoad + ');"></body>' +
 						// It looks strange, but for FF2, the styles must go
 						// after <body>, so it (body) becames immediatelly
@@ -172,5 +173,6 @@
 				doc.on( 'keydown', function( evt )
 					{
-						var keystroke = evt.data.getKeystroke();
+						var keystroke = evt.data.getKeystroke(),
+							dir = this.document.getById( 'cke_' + this.id ).getAttribute( 'dir' );
 
 						// Delegate key processing to block.
@@ -181,6 +183,10 @@
 						}
 
-						if ( keystroke == 27 )		// ESC
-							this.onEscape && this.onEscape();
+						// ESC/ARROW-LEFT(ltr) OR ARROW-RIGHT(rtl)
+						if ( keystroke == 27 || keystroke == ( dir == 'rtl' ? 39 : 37 ) )
+						{
+							if ( this.onEscape && this.onEscape( keystroke ) === false )
+								evt.data.preventDefault( );
+						}
 					},
 					this );
@@ -199,5 +205,6 @@
 	addBlock : function( name, block )
 	{
-		block = this._.blocks[ name ] = block || new CKEDITOR.ui.panel.block( this.getHolderElement() );
+		block = this._.blocks[ name ] = block instanceof CKEDITOR.ui.panel.block ?  block
+				: new CKEDITOR.ui.panel.block( this.getHolderElement(), block );
 
 		if ( !this._.currentBlock )
@@ -216,10 +223,20 @@
 		var blocks = this._.blocks,
 			block = blocks[ name ],
-			current = this._.currentBlock;
+			current = this._.currentBlock,
+			holder = this.forceIFrame ?
+				this.document.getById( 'cke_' + this.id + '_frame' )
+				: this._.holder;
 
 		if ( current )
+		{
+			// Clean up the current block's effects on holder.
+			holder.removeAttributes( current.attributes );
 			current.hide();
+		}
 
 		this._.currentBlock = block;
+
+		holder.setAttributes( block.attributes );
+		CKEDITOR.fire( 'ariaWidget', holder );
 
 		// Reset the focus index, so it will always go into the first one.
@@ -241,5 +258,5 @@
 CKEDITOR.ui.panel.block = CKEDITOR.tools.createClass(
 {
-	$ : function( blockHolder )
+	$ : function( blockHolder, blockDefinition )
 	{
 		this.element = blockHolder.append(
@@ -248,5 +265,7 @@
 					attributes :
 					{
-						'class' : 'cke_panel_block'
+						'tabIndex' : -1,
+						'class' : 'cke_panel_block',
+						'role' : 'presentation'
 					},
 					styles :
@@ -256,4 +275,8 @@
 				}) );
 
+		// Copy all definition properties to this object.
+		if ( blockDefinition )
+			CKEDITOR.tools.extend( this, blockDefinition );
+
 		this.keys = {};
 
@@ -264,5 +287,23 @@
 	},
 
-	_ : {},
+	_ : {
+
+		/**
+		 * Mark the item specified by the index as current activated.
+		 */
+		markItem: function( index )
+		{
+			if ( index == -1 )
+				return;
+			var links = this.element.getElementsByTag( 'a' );
+			var item = links.getItem( this._.focusIndex = index );
+
+			// Safari need focus on the iframe window first(#3389), but we need
+			// lock the blur to avoid hiding the panel.
+			if ( CKEDITOR.env.webkit )
+				item.getDocument().getWindow().focus();
+			item.focus();
+		}
+	},
 
 	proto :
Index: CKEditor/trunk/_source/plugins/panelbutton/plugin.js
===================================================================
--- CKEditor/trunk/_source/plugins/panelbutton/plugin.js	(revision 5181)
+++ CKEditor/trunk/_source/plugins/panelbutton/plugin.js	(revision 5189)
@@ -1,3 +1,3 @@
-﻿/*
+/*
 Copyright (c) 2003-2010, CKSource - Frederico Knabben. All rights reserved.
 For licensing, see LICENSE.html or http://ckeditor.com/license
@@ -58,4 +58,9 @@
 							|| CKEDITOR.document;
 
+			panelDefinition.block =
+			{
+				attributes : panelDefinition.attributes
+			};
+
 			this.hasArrow = true;
 
@@ -89,6 +94,8 @@
 
 				var panelDefinition = this._.panelDefinition || {},
+					 panelBlockDefinition = this._.panelDefinition.block,
 					panelParentElement = panelDefinition.parent || CKEDITOR.document.getBody(),
 					panel = this._.panel = new CKEDITOR.ui.floatPanel( editor, panelParentElement, panelDefinition ),
+					block = panel.addBlock( _.id, panelBlockDefinition ),
 					me = this;
 
@@ -127,7 +134,7 @@
 
 				if ( this.onBlock )
-					this.onBlock( panel, _.id );
+					this.onBlock( panel, block );
 
-				panel.getBlock( _.id ).onHide = function()
+				block.onHide = function()
 						{
 								_.on = 0;
Index: CKEditor/trunk/_source/plugins/pastetext/dialogs/pastetext.js
===================================================================
--- CKEditor/trunk/_source/plugins/pastetext/dialogs/pastetext.js	(revision 5181)
+++ CKEditor/trunk/_source/plugins/pastetext/dialogs/pastetext.js	(revision 5189)
@@ -56,4 +56,13 @@
 										'background-color:white">' +
 									'</textarea>',
+
+								onLoad : function()
+								{
+									var label = this.getDialog().getContentElement( 'general', 'pasteMsg' ).getElement(),
+										input = this.getElement();
+
+									input.setAttribute( 'aria-labelledby', label.$.id );
+								},
+
 								focus : function()
 								{
